/***************************************************************************
 *   Copyright (C) %{CURRENT_YEAR} by %{AUTHOR} <%{EMAIL}>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef DANBOORU_CLIENT_H
#define DANBOORU_CLIENT_H


#include <KXmlGuiWindow>

namespace Danbooru {

    class DanbooruClientView;
    class DanbooruService;
    class DanbooruPostModel;

    /**
     * This class serves as the main window for danbooru_client.  It handles the
     * menus, toolbars and status bars.
     *
     * @short Main window class
     * @author Luca Beltrame <lbeltrame@kde.org>
     * @version 0.01
     */
    class DanbooruMainWindow : public KXmlGuiWindow
    {
        Q_OBJECT
    public:
        /**
         * Default Constructor
         */
        DanbooruMainWindow();

        /**
         * Default Destructor
         */
        virtual ~DanbooruMainWindow();

    private Q_SLOTS:
        void connectToBoard();
        void downloadPosts();
        void optionsPreferences();

    private:
        void setupActions();
        void setupConnections();

    private:
        DanbooruClientView *m_view;
        DanbooruPostModel* m_model;
        DanbooruService* m_service;


    };
} // namespace Danbooru

#endif // _DANBOORU_CLIENT_H_
